/* Automatically generated by Kelbt from "rlparse.kh".
 *
 * Parts of this file are copied from Kelbt source covered by the GNU
 * GPL. As a special exception, you may use the parts of this file copied
 * from Kelbt source without restriction. The remainder is derived from
 * "rlparse.kh" and inherits the copyright status of that file.
 */

/*
 *  Copyright 2006 Adrian Thurston <thurston@cs.queensu.ca>
 */

/*  This file is part of Ragel.
 *
 *  Ragel is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Ragel is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Ragel; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef RLPARSE_H
#define RLPARSE_H

#include <iostream>
#include "avltree.h"
#include "parsedata.h"

extern char *lelNames[];

struct LangEl;

struct Parser
{
	#line 45 "rlparse.h"
#define KW_Machine 128
#define KW_Include 129
#define KW_Write 130
#define TK_Word 131
#define TK_Literal 132
#define TK_Number 133
#define TK_Inline 134
#define TK_Reference 135
#define TK_ColonEquals 136
#define TK_EndSection 137
#define TK_UInt 138
#define TK_Hex 139
#define TK_BaseClause 140
#define TK_DotDot 141
#define TK_ColonGt 142
#define TK_ColonGtGt 143
#define TK_LtColon 144
#define TK_Arrow 145
#define TK_DoubleArrow 146
#define TK_StarStar 147
#define TK_NameSep 148
#define TK_BarStar 149
#define TK_DashDash 150
#define TK_StartCond 151
#define TK_AllCond 152
#define TK_LeavingCond 153
#define TK_Middle 154
#define TK_StartGblError 155
#define TK_AllGblError 156
#define TK_FinalGblError 157
#define TK_NotFinalGblError 158
#define TK_NotStartGblError 159
#define TK_MiddleGblError 160
#define TK_StartLocalError 161
#define TK_AllLocalError 162
#define TK_FinalLocalError 163
#define TK_NotFinalLocalError 164
#define TK_NotStartLocalError 165
#define TK_MiddleLocalError 166
#define TK_StartEOF 167
#define TK_AllEOF 168
#define TK_FinalEOF 169
#define TK_NotFinalEOF 170
#define TK_NotStartEOF 171
#define TK_MiddleEOF 172
#define TK_StartToState 173
#define TK_AllToState 174
#define TK_FinalToState 175
#define TK_NotFinalToState 176
#define TK_NotStartToState 177
#define TK_MiddleToState 178
#define TK_StartFromState 179
#define TK_AllFromState 180
#define TK_FinalFromState 181
#define TK_NotFinalFromState 182
#define TK_NotStartFromState 183
#define TK_MiddleFromState 184
#define RE_Slash 185
#define RE_SqOpen 186
#define RE_SqOpenNeg 187
#define RE_SqClose 188
#define RE_Dot 189
#define RE_Star 190
#define RE_Dash 191
#define RE_Char 192
#define IL_WhiteSpace 193
#define IL_Comment 194
#define IL_Literal 195
#define IL_Symbol 196
#define KW_Action 197
#define KW_AlphType 198
#define KW_Range 199
#define KW_GetKey 200
#define KW_When 201
#define KW_Eof 202
#define KW_Err 203
#define KW_Lerr 204
#define KW_To 205
#define KW_From 206
#define KW_Break 207
#define KW_Exec 208
#define KW_Hold 209
#define KW_PChar 210
#define KW_Char 211
#define KW_Goto 212
#define KW_Call 213
#define KW_Ret 214
#define KW_CurState 215
#define KW_TargState 216
#define KW_Entry 217
#define KW_Next 218
#define KW_Variable 219
#define KW_Access 220
#define TK_Semi 221
#define _eof 222

	LangEl *freshEl;
	int freshPos;
	LangEl *pool;
	int numRetry;
	int numNodes;
	LangEl *stackTop;
	LangEl *lastFinal;
	int errCount;
	int curs;

	int init();
	int parseLangEl( int type, const Token &token );
	int finish();

#line 1 "rlparse.kh"


	Parser( char *fileName, char *sectionName, InputLoc &sectionLoc )
		: sectionName(sectionName)
	{
		pd = new ParseData( fileName, sectionName, sectionLoc );
	}

	int token( InputLoc &loc, int tokId, char *tokstart, int toklen );
	void tryMachineDef( InputLoc &loc, char *name, 
		JoinOrLm *joinOrLm, bool isInstance );

	/* Report an error encountered by the parser. */
	ostream &parser_error( int tokId, Token &token );

	ParseData *pd;

	/* The name of the root section, this does not change during an include. */
	char *sectionName;

	NameRef nameRef;
	NameRefList nameRefList;
};

#endif
