/* Automatically generated by Kelbt from "xmlparse.kh".
 *
 * Parts of this file are copied from Kelbt source covered by the GNU
 * GPL. As a special exception, you may use the parts of this file copied
 * from Kelbt source without restriction. The remainder is derived from
 * "xmlparse.kh" and inherits the copyright status of that file.
 */

/*
 *  Copyright 2001-2007 Adrian Thurston <thurston@cs.queensu.ca>
 */

/*  This file is part of Ragel.
 *
 *  Ragel is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Ragel is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Ragel; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */
#ifndef _XMLPARSE_H
#define _XMLPARSE_H

#include "vector.h"
#include "rlcodegen.h"
#include "gendata.h"
#include <iostream>

using std::ostream;

struct XMLTagHashPair
{
    char *name;
    int id;
};

struct Token
{
	XMLTag *tag;
	InputLoc loc;
};

struct InlineItem;
struct InlineList;

struct LmSwitchVect;
struct LmSwitchAction;

extern char *lelNames[];

struct LangEl;

struct Parser
{
	#line 65 "xmlparse.h"
#define TAG_unknown 128
#define TAG_ragel 129
#define TAG_ragel_def 130
#define TAG_host 131
#define TAG_state_list 132
#define TAG_state 133
#define TAG_trans_list 134
#define TAG_t 135
#define TAG_machine 136
#define TAG_start_state 137
#define TAG_action_list 138
#define TAG_action_table_list 139
#define TAG_action 140
#define TAG_action_table 141
#define TAG_alphtype 142
#define TAG_element 143
#define TAG_getkey 144
#define TAG_state_actions 145
#define TAG_entry_points 146
#define TAG_sub_action 147
#define TAG_cond_space_list 148
#define TAG_cond_space 149
#define TAG_cond_list 150
#define TAG_c 151
#define TAG_text 152
#define TAG_goto 153
#define TAG_call 154
#define TAG_next 155
#define TAG_goto_expr 156
#define TAG_call_expr 157
#define TAG_next_expr 158
#define TAG_ret 159
#define TAG_pchar 160
#define TAG_char 161
#define TAG_hold 162
#define TAG_exec 163
#define TAG_holdte 164
#define TAG_execte 165
#define TAG_curs 166
#define TAG_targs 167
#define TAG_entry 168
#define TAG_data 169
#define TAG_lm_switch 170
#define TAG_init_act 171
#define TAG_set_act 172
#define TAG_set_tokend 173
#define TAG_get_tokend 174
#define TAG_init_tokstart 175
#define TAG_set_tokstart 176
#define TAG_write 177
#define TAG_curstate 178
#define TAG_access 179
#define TAG_break 180
#define TAG_option 181
#define _eof 182

	LangEl *freshEl;
	int freshPos;
	LangEl *pool;
	int numRetry;
	int numNodes;
	LangEl *stackTop;
	LangEl *lastFinal;
	int errCount;
	int curs;

	int init();
	int parseLangEl( int type, const Token &token );
	int finish();

#line 1 "xmlparse.kh"


	Parser( char *fileName )
		: fileName(fileName), sourceFileName(0) { }

	int token( int tokenId, Token &token );
	int token( int tokenId, int col, int line );
	int token( XMLTag *tag, int col, int line );

	/* Report an error encountered by the parser. */
	ostream &warning( const InputLoc &loc );
	ostream &error();
	ostream &error( const InputLoc &loc );
	ostream &parser_error( int tokId, Token &token );

	/* The name of the root section, this does not change during an include. */
	char *fileName;

	/* Collected during parsing. */
	char *sourceFileName;
	char *attrKey;
	char *attrValue;
	int curAction;
	int curActionTable;
	int curTrans;
	int curState;
	int curCondSpace;
	int curStateCond;

	CodeGenMap codeGenMap;
};

#endif /* _XMLPARSE_H */
